
menu_windows = newRolloutFloater "FFD Magic" 180 175
cui.RegisterDialogBar menu_windows  style:#(#cui_dock_all, #cui_floatable, #cui_handles)

rollout ffdDummiesRollout "" width:162 height:220
(
	button btnGo "Create Points" pos:[8,70] width:144 height:20
	pickbutton btnPickSubject "Pick FFD SpaceWarp" pos:[8,20] width:144 height:20 toolTip:"" autoDisplay:true
	edittext edtDummyName "Name" pos:[10,45] width:142 height:16
	label lbl3 "" pos:[10,0] width:144 height:20 align:#left
	--button btnSubjectcopy "Copy Mod" pos:[8,100] width:60 height:20 toolTip:"Choose Object with FFD modifier" autoDisplay:true
	button btnSubjectpaste "Magic" pos:[50,100] width:60 height:20 toolTip:"" autoDisplay:true
	hyperLink web  "dg3duy" align:#right offset:[10, 5] color:[255,255,255] hoverColor:[255,130,0] visitedColor:(color 0 2550 192)  address:"http://www.darwingiordano.com"

	
	
	
	on btnGo pressed do
	(
	theOne = btnPickSubject.object
	theMod = undefined
	if (theOne != undefined) then
	(
		for imod = 1 to theOne.modifiers.count do
		(
			mm = theOne.modifiers[imod]
			if isKindOf mm FFD_2x2x2 then theMod = mm
			if isKindOf mm FFD_3x3x3 then theMod = mm
			if isKindOf mm FFD_4x4x4 then theMod = mm
			if isKindOf mm FFDBox   then theMod = mm
			if isKindOf mm FFDCyl   then theMod = mm
		)
	)
	if (theMod == undefined) then
	(
		MessageBox "Pick an FFD Spacewarp with an FFD modifier first."
		return 0
	)
	
	oldRange  = animationRange
	animationRange = interval 0 10000	
	animateAll theMod
	n = 1
	while isProperty theMod ("control_point_" + n as string) do
	(
		controls = #()
		controls[n] = point3_script()
		posNow = getProperty theMod ("control_point_" + n as string)
		setPropertyController theMod ("control_point_" + n as string) controls[n]
		
		dummies = #()
		dummies[n] = point()
		
		boxmin = getModContextBBoxMin theOne theMod
		boxlen = (getModContextBBoxMax theOne theMod) - boxmin
		posLoc = boxmin + posNow*boxLen
		posGlob = posLoc * theOne.transform
		
		dummies[n].pos = posGlob
		dummies[n].name = uniquename ("Character_FFD" + edtDummyName.text + "_")
		dummies[n].size = 3
		dummies[n].Box = on


		
		controls[n].AddNode "theOne" theOne
		controls[n].AddNode "theDummy" dummies[n]
		
		
		st  = stringstream ""
		format "theDummy = $% \n" dummies[n]
		format "theOne = $% \n" theOne
		format "theMod = theOne.modifiers[1]\n" to: st
		format "posGlob = theDummy.pos\n" to:st
		format "posLoc  = posGlob * (inverse theOne.transform)\n" to:st
		format "boxMin = getModContextBBoxMin theOne theMod\n" to:st
		format "boxLen = (getModContextBBoxMax theOne theMod) - boxmin\n" to:st
		format "posBox  = (posLoc - boxMin) / boxLen\n" to:st
		
		--print st
		
		controls[n].script = st
		

		n += 1

		
	)
	animationrange = oldrange
	
    theOne.Transform.controller = transform_script ()
    theOne.modifiers[#FFD_2x2x2].Lattice_Transform.controller = transform_script ()

	nodes = Execute ("$Character_FFD"+edtDummyName.text+"*");
	select nodes
	
	sel = selection as array

	Grupo= sel

	gr = group Grupo name:(uniquename "Character_Group_FFD_" + "_" +edtDummyName.text)

	max select none

		select theOne
	
		s =  transform_script ()
		objeto= gr
		
 		s.AddNode "objeto" objeto
		
 		str  = stringstream ""
		format "theOne = $% \n" object
		format "objeto.transform" to: str
		
 		s.script = str
		
		
		--------------------------
		ss =  transform_script ()
		objeto= gr
		
 		ss.AddNode "objeto" objeto
		
		 		strr  = stringstream ""
		format "theOne = $% \n" object
		format "objeto.transform" to: strr
		
 		ss.script = strr
		
 
	(
    for theNode in selection do
        for index = theNode.modifiers.count to 1 by -1 do
            if ((classOf theNode.modifiers[index]) == FFD_2x2x2) do
                theNode.modifiers[1].Lattice_Transform.controller = s
	)
    theOne.Transform.controller = ss

	 -----Ungroup
	for x in gr where (isgrouphead x) do
	(
				setGroupOpen x true

	)
	----------


	mm = for node in gr where isgroupmember node collect node	
	hh = for node in gr where isgrouphead node collect node	
	gh = for node in gr where isgrouphead node do exit with node	

	(	
		format "\n"	

		format "(mm) group memebers:\n\t%\n" (for m in mm collect m.name)
		format "(hh) group heads:\n\t%\n" (for h in hh collect h.name)

		format "\n"	

	)

	)
	
		on btnSubjectcopy pressed do
	(
	lModifier = copy  $.modifiers[1] --we've got a selected object

	)
	on btnSubjectpaste pressed do
	(
	--addModifier $ lModifier


	gr2 = $
		
	    gr2.modifiers[#FFD_2x2x2].Lattice_Transform.controller = transform_script ()

		s2 =  gr2.modifiers[#FFD_2x2x2].Lattice_Transform.controller
		objeto2= gr
		
 		s2.AddNode "objeto" objeto2
		
 		str2  = stringstream ""
		format "gr2 = $% \n" object
		format "modObj = (refs.dependentNodes this)[1]\n" to: str2
		format "if (classof modObj[#transform])==SubAnim then modObj.transform.controller\n" to: str2
		format "mCtxTM = (matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0])\n" to: str2
		format "if (isValidNode objeto) and (isValidNode modObj) then (\n" to: str2
		format " ctrlTrans = (matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0]) * (objeto.transform * mCtxTM * inverse modObj.objectTransform)\n" to: str2
		format ") else (matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0])\n" to: str2

 		s2.script = str2

	)



	
	
	
)

addRollout ffdDummiesRollout menu_windows

